﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace RichterRemote
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private int devices = 0;

		public MainWindow()
		{
			InitializeComponent();
		}

		public static string GetLocalIPAddress()
		{
			var host = Dns.GetHostEntry(Dns.GetHostName());
			foreach (var ip in host.AddressList)
			{
				if (ip.AddressFamily == AddressFamily.InterNetwork)
				{
					return ip.ToString();
				}
			}
			throw new Exception("No network adapters with an IPv4 address in the system!");
		}

		protected override void OnClosing(CancelEventArgs e)
		{
			base.OnClosing(e);
			Environment.Exit(0);
		}

		private void Button_on_Click(object sender, RoutedEventArgs e)
		{
			devices = 0;
			var myIp = GetLocalIPAddress();
			var iparray = IPBuilder(myIp);
			foreach (var ip in iparray)
			{
				var work = new Thread(() =>
				{
					try
					{
						TcpClient client = new TcpClient(ip, 9512)
						{
							ReceiveTimeout = 10,
							SendTimeout = 10
						};
						if (client.Connected)
						{
							var networkStream = client.GetStream();
							networkStream.Write(new []{(byte)6,(byte)9,(byte)1,(byte)0}, 0, 4);
							devices++;
							Dispatcher.Invoke(() => {
								textBox.Text = $"Eszközök: {devices}db"; });
						}
					}
					catch (Exception exception)
					{
						Console.WriteLine(exception);
					}
				});
				work.Start();
			}
		}

		private void Button_off_Click(object sender, RoutedEventArgs e)
		{
			devices = 0;
			var myIp = GetLocalIPAddress();
			var iparray = IPBuilder(myIp);
			foreach (var ip in iparray)
			{
			var work = new Thread(() =>
			{
				try
				{
					TcpClient client = new TcpClient(ip, 9512)
					{
						ReceiveTimeout = 10,
						SendTimeout = 10
					};
					if (client.Connected)
					{
						var networkStream = client.GetStream();
						networkStream.Write(new []{(byte)6,(byte)9,(byte)0,(byte)0}, 0, 4);
						devices++;
						Dispatcher.Invoke(() => {
							textBox.Text = $"Eszközök: {devices}db"; });
					}
				}
				catch (Exception exception)
				{
					Console.WriteLine(exception);
				}
			});
			work.Start();
			}
		}

		string[] IPBuilder(string ip)
		{

			var baseip = ip.Remove(ip.LastIndexOf('.') + 1);

			var iplist = new List<string>();
			for (int i = 1; i < 255; i++)
			{
				iplist.Add(baseip + i);
			}

			return iplist.ToArray();
		}
	}
}
